/* This is the wrapper program for LyX/Cygwin. Using this
 * wrapper program no DOS window will be present running LyX.
 * The bad side of this: no error output could be seen ;-)
 *
 * It launches the real binary lyx-qtwin.exe using the native Windows GUI.
 *
 * compile this source with following options set:
 *
 *    gcc lyx-win.c -O2 -o lyx-win -static -Wall -Wno-format \
 *                   -Wstrict-prototypes -Wmissing-prototypes \
 *                   -mwindows -e _mainCRTStartup
 *
 * Claus Hentschel, 2002-01-17
 * Enrico Forestieri, 2007-07-30
 */
#include <stdio.h>            /* standard io library */
#include <stdlib.h>           /* standard library */
#include <unistd.h>           /* sleep */
#include <process.h>          /* spawnv */
#include <ctype.h>            /* isblank */
#include <string.h>           /* standard string library */
#include <limits.h>           /* PATH_MAX */
#include <sys/cygwin.h>       /* cygwin_conv_to_posix_path */
#include <errno.h>
#include <windows.h>

int main (int argc, char **argv, char **environ)
{
    FILE *fp;
    char *s;
    char posixpath[PATH_MAX];         /* converted path */
    char cmd[4096] = "lyx-qtwin ";    /* user command */
    char const *nargs[5] = {          /* execute with login /bin/bash */
	    "/bin/bash", "--login",
	    "-c" , cmd ,
	    NULL
    };
    int i = 1; /* just to count */

    /* do for all "real" args */
    while (i < argc)
    {
	int done = 0;
	int lyxfile = (s = strrchr(argv[i], '.')) && strcasecmp(s, ".lyx") == 0;
	strcat(cmd, "\""); /* add quote before */
	cygwin_conv_to_posix_path(argv[i], posixpath) ;
	/* Hack to account for shares */
	if (lyxfile && argv[i][0] == '\\' && argv[i][1] != '\\')
	    strcat(cmd, "/");
	strcat(cmd, posixpath); /* add the argument */
	strcat(cmd, "\" "); /* add closing quote */
	if (!done && lyxfile && (s = strrchr(posixpath,'/')))
	{
	    done = 1;
	    fp = fopen("/tmp/cdpath","w");
	    if (fp)
	    {
		*s = 0;
		fprintf(fp, "%s\n", posixpath);
		fclose(fp);
	    }
	}
	++i;
    }

    strcat(cmd, "</dev/null 1>/dev/null 2>&1");

    /* fprintf(stderr , "Command is: |%s|\n", cmd); */
    /* ensure bash reads our global env changes */
    putenv("BASH_ENV=/etc/lyxprofile") ;
    spawnv(_P_NOWAIT, "/bin/bash", nargs);  /* exec sub command */
    return(0) ; /* exit with no error */
}
