/* This is a wrapper program for lyxeditor.sh or lyxclient, meant to be used
 * with yap for inverse dvi search.
 *
 * compile this source with following options set:
 *
 *    gcc lyxeditor.c -O2 -o lyxeditor -static -mwindows -e _mainCRTStartup
 *
 * Enrico Forestieri, 2008-05-24
 */

#include <stdio.h>	/* standard io library */
#include <stdlib.h>	/* system() */
#include <limits.h>	/* PATH_MAX */
#include <sys/cygwin.h>	/* cygwin_conv_to_posix_path() */

int main(int ac, char **av)
{
    char buf[2 * PATH_MAX];
    char posixpath[PATH_MAX];

    if (ac < 3 | ac > 4)
	return 1;

    if (ac == 3) {
	cygwin_conv_to_posix_path(av[1], posixpath);
	sprintf(buf, "lyxeditor.sh '%s' %s", posixpath, av[2]);
    } else {
	cygwin_conv_to_posix_path(av[2], posixpath);
	sprintf(buf, "lyxclient %s '%s' %s", av[1], posixpath, av[3]);
    }
    system(buf);
    return 0;
}
